diff -Nur nginx-1.1.11.orig/src/http/modules/ngx_http_fastcgi_module.c nginx-1.1.11/src/http/modules/ngx_http_fastcgi_module.c
--- nginx-1.1.11.orig/src/http/modules/ngx_http_fastcgi_module.c	2011-12-09 21:32:51.000000000 +0800
+++ nginx-1.1.11/src/http/modules/ngx_http_fastcgi_module.c	2011-12-19 13:52:43.431468931 +0800
@@ -287,6 +287,16 @@
       offsetof(ngx_http_fastcgi_loc_conf_t, upstream.pass_request_body),
       NULL },
 
+    // twu2 begin
+    // option to skip 404 error
+    { ngx_string("fastcgi_intercept_error_skip_404"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_FLAG,
+      ngx_conf_set_flag_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_fastcgi_loc_conf_t, upstream.intercept_error_skip_404),
+      NULL },
+    // twu2 edn
+
     { ngx_string("fastcgi_intercept_errors"),
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_FLAG,
       ngx_conf_set_flag_slot,
@@ -2092,6 +2102,10 @@
     conf->upstream.pass_headers = NGX_CONF_UNSET_PTR;
 
     conf->upstream.intercept_errors = NGX_CONF_UNSET;
+    // twu2 begin
+    // option to skip 404 error
+    conf->upstream.intercept_error_skip_404 = NGX_CONF_UNSET;
+    // twu2 end
 
     /* "fastcgi_cyclic_temp_file" is disabled */
     conf->upstream.cyclic_temp_file = 0;
@@ -2332,6 +2346,11 @@
 
     ngx_conf_merge_value(conf->upstream.intercept_errors,
                               prev->upstream.intercept_errors, 0);
+    // twu2 begin
+    // option to skip 404 error
+    ngx_conf_merge_value(conf->upstream.intercept_errors,
+                              prev->upstream.intercept_errors, 0);
+    // twu2 end
 
     ngx_conf_merge_ptr_value(conf->catch_stderr, prev->catch_stderr, NULL);
 
diff -Nur nginx-1.1.11.orig/src/http/ngx_http_upstream.c nginx-1.1.11/src/http/ngx_http_upstream.c
--- nginx-1.1.11.orig/src/http/ngx_http_upstream.c	2011-12-09 21:19:57.000000000 +0800
+++ nginx-1.1.11/src/http/ngx_http_upstream.c	2011-12-19 13:49:21.476532705 +0800
@@ -1742,6 +1742,12 @@
         return NGX_DECLINED;
     }
 
+    // twu2 begin
+    // don't intercept 404 error (it will be processed by upstream)
+    if (status == NGX_HTTP_NOT_FOUND && u->conf->intercept_error_skip_404)
+        return NGX_DECLINED;
+    // twu2 end
+
     clcf = ngx_http_get_module_loc_conf(r, ngx_http_core_module);
 
     if (clcf->error_pages == NULL) {
diff -Nur nginx-1.1.11.orig/src/http/ngx_http_upstream.h nginx-1.1.11/src/http/ngx_http_upstream.h
--- nginx-1.1.11.orig/src/http/ngx_http_upstream.h	2011-12-09 21:19:57.000000000 +0800
+++ nginx-1.1.11/src/http/ngx_http_upstream.h	2011-12-19 13:50:22.147014289 +0800
@@ -148,6 +148,10 @@
 
     ngx_flag_t                       ignore_client_abort;
     ngx_flag_t                       intercept_errors;
+    // twu2 begin
+    // add an option to skip intercept 404 error
+    ngx_flag_t                       intercept_error_skip_404;
+    // twu2 end
     ngx_flag_t                       cyclic_temp_file;
 
     ngx_path_t                      *temp_path;
